<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="20131001" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:C_Cpp="http://www.eclipse.org/papyrus/C_Cpp/1" xmlns:ecore="http://www.eclipse.org/emf/2002/Ecore" xmlns:robotics.components="http://www.eclipse.org/papyrus/robotics/components/1" xmlns:robotics.functions="http://www.eclipse.org/papyrus/robotics/functions/1" xmlns:robotics.generics="http://www.eclipse.org/papyrus/robotics/generics/1" xmlns:robotics.parameters="http://www.eclipse.org/papyrus/robotics/parameters/1" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML" xsi:schemaLocation="http://www.eclipse.org/papyrus/robotics/components/1 http://www.eclipse.org/papyrus/robotics/1#//components http://www.eclipse.org/papyrus/robotics/functions/1 http://www.eclipse.org/papyrus/robotics/1#//functions http://www.eclipse.org/papyrus/robotics/generics/1 http://www.eclipse.org/papyrus/robotics/1#//generics http://www.eclipse.org/papyrus/robotics/parameters/1 http://www.eclipse.org/papyrus/robotics/1#//parameters">
  <uml:Model xmi:id="_7dB2wA6rEeqas7S1-hM4Zg" name="dummy_laserCompdef">
    <packageImport xmi:type="uml:PackageImport" xmi:id="_7dB2wQ6rEeqas7S1-hM4Zg">
      <importedPackage xmi:type="uml:Model" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#_0"/>
    </packageImport>
    <packageImport xmi:type="uml:PackageImport" xmi:id="_7dB2wg6rEeqas7S1-hM4Zg">
      <importedPackage xmi:type="uml:Model" href="pathmap://ROBOTICS_LIBRARIES/robotics.library.uml#_LaOOAJcvEeeV0-Lu2yLOjA"/>
    </packageImport>
    <packagedElement xmi:type="uml:Class" xmi:id="_lXxIcQ6uEeqas7S1-hM4Zg" name="Dummy_laser">
      <ownedAttribute xmi:type="uml:Port" xmi:id="_li8dsA6uEeqas7S1-hM4Zg" name="scan" type="_li9r0A6uEeqas7S1-hM4Zg"/>
      <ownedAttribute xmi:type="uml:Property" xmi:id="_umZeIBHCEeq9S-Gi7Vl9nA" name="msg">
        <type xmi:type="uml:DataType" href="pathmap://ROS2_LIB_BASE/services/sensor_msgs.servicedef.uml#ID_msg_LaserScan"/>
      </ownedAttribute>
      <ownedAttribute xmi:type="uml:Property" xmi:id="_xiL50BHCEeq9S-Gi7Vl9nA" name="activity1" type="_xiAToBHCEeq9S-Gi7Vl9nA"/>
      <ownedAttribute xmi:type="uml:Property" xmi:id="_w9yj8BIdEeqtEsIQCy1CFQ" name="counter">
        <type xmi:type="uml:PrimitiveType" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#Real"/>
      </ownedAttribute>
      <ownedConnector xmi:type="uml:Connector" xmi:id="_7fM8kBHCEeq9S-Gi7Vl9nA">
        <end xmi:type="uml:ConnectorEnd" xmi:id="_7fgekBHCEeq9S-Gi7Vl9nA" role="_li8dsA6uEeqas7S1-hM4Zg"/>
        <end xmi:type="uml:ConnectorEnd" xmi:id="_7fhssBHCEeq9S-Gi7Vl9nA" partWithPort="_xiL50BHCEeq9S-Gi7Vl9nA" role="_5Mc20BHCEeq9S-Gi7Vl9nA"/>
      </ownedConnector>
      <nestedClassifier xmi:type="uml:Class" xmi:id="_li9r0A6uEeqas7S1-hM4Zg">
        <interfaceRealization xmi:type="uml:InterfaceRealization" xmi:id="_ljBWMA6uEeqas7S1-hM4Zg" client="_li9r0A6uEeqas7S1-hM4Zg">
          <supplier xmi:type="uml:Interface" href="pathmap://ROS2_LIB_BASE/services/sensor_msgs.servicedef.uml#svcdefs/P_LaserScan"/>
          <contract xmi:type="uml:Interface" href="pathmap://ROS2_LIB_BASE/services/sensor_msgs.servicedef.uml#svcdefs/P_LaserScan"/>
        </interfaceRealization>
      </nestedClassifier>
      <nestedClassifier xmi:type="uml:Class" xmi:id="_vT73kA9nEeq4SdRfpcPmcg">
        <ownedAttribute xmi:type="uml:Property" xmi:id="_5cmBEBHBEeq9S-Gi7Vl9nA" name="angle_resolution">
          <type xmi:type="uml:PrimitiveType" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#Real"/>
          <defaultValue xmi:type="uml:LiteralReal" xmi:id="_T2wLsBHCEeq9S-Gi7Vl9nA" value="2500.0"/>
        </ownedAttribute>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_-Gx4QBHBEeq9S-Gi7Vl9nA" name="start_angle">
          <type xmi:type="uml:PrimitiveType" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#Real"/>
          <defaultValue xmi:type="uml:LiteralReal" xmi:id="_WYkBIBHCEeq9S-Gi7Vl9nA" value="-450000.0"/>
        </ownedAttribute>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_AJaeYBHCEeq9S-Gi7Vl9nA" name="stop_angle">
          <type xmi:type="uml:PrimitiveType" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#Real"/>
          <defaultValue xmi:type="uml:LiteralReal" xmi:id="_YkoQEBHCEeq9S-Gi7Vl9nA" value="2250000.0"/>
        </ownedAttribute>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_Bf37ABHCEeq9S-Gi7Vl9nA" name="scan_frequency">
          <type xmi:type="uml:PrimitiveType" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#Real"/>
          <defaultValue xmi:type="uml:LiteralReal" xmi:id="_bU5_UBHCEeq9S-Gi7Vl9nA" value="2500.0"/>
        </ownedAttribute>
      </nestedClassifier>
      <nestedClassifier xmi:type="uml:Class" xmi:id="_xiAToBHCEeq9S-Gi7Vl9nA" name="Activity1">
        <generalization xmi:type="uml:Generalization" xmi:id="_xiD-ABHCEeq9S-Gi7Vl9nA">
          <general xmi:type="uml:Class" href="pathmap://ROBOTICS_LIBRARIES/robotics.library.uml#_dFzyYPn9Eee8c8wpObBu7w"/>
        </generalization>
        <ownedAttribute xmi:type="uml:Port" xmi:id="_5Mc20BHCEeq9S-Gi7Vl9nA" name="port" aggregation="composite"/>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_G_l5wBHHEeq9e7Na0zqf8A" name="activate" type="_FLYKIBHHEeq9e7Na0zqf8A"/>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_daD2sBH-Eeq9e7Na0zqf8A" name="periodic" type="_cjOVUBH-Eeq9e7Na0zqf8A"/>
      </nestedClassifier>
    </packagedElement>
    <packagedElement xmi:type="uml:Usage" xmi:id="_livpYA6uEeqas7S1-hM4Zg">
      <supplier xmi:type="uml:Interface" href="pathmap://ROS2_LIB_BASE/services/rcl_interfaces.servicedef.uml#svcdefs/P_ParameterEvent"/>
    </packagedElement>
    <packagedElement xmi:type="uml:OpaqueBehavior" xmi:id="_FLYKIBHHEeq9e7Na0zqf8A" name="activateFct" isAbstract="true">
      <language>C++</language>
      <body>msg.header.frame_id = &quot;single_rrbot_hokuyo_link&quot;;

double angle_resolution = 2500;
double start_angle = -450000;
double stop_angle = 2250000;
double scan_frequency = 2500;

double angle_range = stop_angle - start_angle;
double num_values = angle_range / angle_resolution;
if (static_cast&lt;int>(angle_range) % static_cast&lt;int>(angle_resolution) == 0) {
	// Include endpoint
	++num_values;
}
msg.ranges.resize(static_cast&lt;int>(num_values));

msg.time_increment =
    static_cast&lt;float>((angle_resolution / 10000.0) / 360.0 / (scan_frequency / 100.0));
msg.angle_increment = static_cast&lt;float>(angle_resolution / 10000.0 * DEG2RAD);
msg.angle_min = static_cast&lt;float>(start_angle / 10000.0 * DEG2RAD - M_PI / 2);
msg.angle_max = static_cast&lt;float>(stop_angle / 10000.0 * DEG2RAD - M_PI / 2);
msg.scan_time = static_cast&lt;float>(100.0 / scan_frequency);
msg.range_min = 0.0f;
msg.range_max = 10.0f;

RCLCPP_INFO(get_logger(), &quot;angle inc:\t%f&quot;, msg.angle_increment);
RCLCPP_INFO(get_logger(), &quot;scan size:\t%zu&quot;, msg.ranges.size());
RCLCPP_INFO(get_logger(), &quot;scan time increment: \t%f&quot;, msg.time_increment);</body>
    </packagedElement>
    <packagedElement xmi:type="uml:OpaqueBehavior" xmi:id="_cjOVUBH-Eeq9e7Na0zqf8A" name="periodicFct" isAbstract="true">
      <language>C++</language>
      <body>auto amplitude = 1;
counter += 0.1;
auto distance = static_cast&lt;float>(std::abs(amplitude * std::sin(counter)));

for (size_t i = 0; i &lt; msg.ranges.size(); ++i) {
	msg.ranges[i] = distance;
}

scan_pub_->publish(msg);</body>
    </packagedElement>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dB2xQ6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dB2xg6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/bpc/1#/"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_BPC_PROFILES/bpc.profile.uml#__9qqMJZ1Eeeq1f8hGgKVzA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dB2xw6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dB2yA6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#/"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#__9qqMJZ1Eeeq1f8hGgKVzA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dB2yQ6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dB2yg6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//components"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_EZ1TgJZ2Eeeq1f8hGgKVzA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dB2yw6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dB2zA6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//commpattern"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_8Z6x8Je6EeeiCOWsEr9OuA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dB2zw6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dB20A6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//deployment"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_tu6OsJe9EeeiCOWsEr9OuA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dB20Q6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dCd0A6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//services"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_SlbOAJe_EeeiCOWsEr9OuA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dCd0Q6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dCd0g6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//commobject"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_bz5AcPCaEeee6ab5J_C5Dg"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dCd0w6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dCd1A6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//functions"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_SV7GwC6LEei0V9-WLHIyvg"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dCd1Q6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dCd1g6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//parameters"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_-pU5oDmpEei--ZsfKWaFtw"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dCd1w6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dCd2A6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//generics"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_eFhjMEnvEeien6eLHpkAxA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dCd2Q6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dCd2g6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/MARTE/1#//MARTE_Foundations/NFPs"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://Papyrus_PROFILES/MARTE.profile.uml#_U_GAoAPMEdyuUt-4qHuVvQ"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7dCd2w6rEeqas7S1-hM4Zg">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7dCd3A6rEeqas7S1-hM4Zg" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/MARTE/1#//MARTE_Annexes/VSL/DataTypes"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://Papyrus_PROFILES/MARTE.profile.uml#_9FdqwA-MEdyLh7muGbCqMw"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_djvS4BerEeqO_rnoLbPeaA">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_djy9QBerEeqO_rnoLbPeaA" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/C_Cpp/1#/"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://PapyrusC_Cpp_PROFILES/C_Cpp.profile.uml#_j9REUByGEduN1bTiWJ0lyw"/>
    </profileApplication>
  </uml:Model>
  <robotics.components:ComponentDefinitionModel xmi:id="_7dCd3Q6rEeqas7S1-hM4Zg" base_Package="_7dB2wA6rEeqas7S1-hM4Zg"/>
  <robotics.components:ComponentDefinition xmi:id="_lX4dMA6uEeqas7S1-hM4Zg" base_Class="_lXxIcQ6uEeqas7S1-hM4Zg"/>
  <robotics.components:ComponentService xmi:id="_ljAvIA6uEeqas7S1-hM4Zg" base_Class="_li9r0A6uEeqas7S1-hM4Zg"/>
  <robotics.parameters:Parameter xmi:id="_vT-T0A9nEeq4SdRfpcPmcg" base_Class="_vT73kA9nEeq4SdRfpcPmcg"/>
  <robotics.components:ComponentPort xmi:id="_P3MP8A9_EeqYjOkV1WinKg" base_Port="_li8dsA6uEeqas7S1-hM4Zg"/>
  <robotics.parameters:ParameterEntry xmi:id="_7EjdYBHBEeq9S-Gi7Vl9nA" base_Property="_5cmBEBHBEeq9S-Gi7Vl9nA"/>
  <robotics.parameters:ParameterEntry xmi:id="_-t4UgBHBEeq9S-Gi7Vl9nA" base_Property="_-Gx4QBHBEeq9S-Gi7Vl9nA"/>
  <robotics.parameters:ParameterEntry xmi:id="_AyTqYBHCEeq9S-Gi7Vl9nA" base_Property="_AJaeYBHCEeq9S-Gi7Vl9nA"/>
  <robotics.parameters:ParameterEntry xmi:id="_CB5qABHCEeq9S-Gi7Vl9nA" base_Property="_Bf37ABHCEeq9S-Gi7Vl9nA"/>
  <robotics.components:Activity xmi:id="_xiJdkBHCEeq9S-Gi7Vl9nA" base_Class="_xiAToBHCEeq9S-Gi7Vl9nA"/>
  <robotics.components:ActivityInstance xmi:id="_xiUcsBHCEeq9S-Gi7Vl9nA" base_Property="_xiL50BHCEeq9S-Gi7Vl9nA"/>
  <robotics.components:ActivityPort xmi:id="_5Mmn0BHCEeq9S-Gi7Vl9nA" base_Port="_5Mc20BHCEeq9S-Gi7Vl9nA"/>
  <robotics.generics:Connects xmi:id="_7fjh4BHCEeq9S-Gi7Vl9nA" base_Connector="_7fM8kBHCEeq9S-Gi7Vl9nA"/>
  <robotics.functions:Function xmi:id="_FLhUEBHHEeq9e7Na0zqf8A" base_Class="_FLYKIBHHEeq9e7Na0zqf8A" kind="ON_ACTIVATE"/>
  <robotics.functions:Function xmi:id="_cjQxkBH-Eeq9e7Na0zqf8A" base_Class="_cjOVUBH-Eeq9e7Na0zqf8A" kind="PERIODIC"/>
  <C_Cpp:Include xmi:id="_hcbbsBerEeqO_rnoLbPeaA" body="#include &lt;math.h>&#xA;#define DEG2RAD M_PI / 180.0" base_class="_lXxIcQ6uEeqas7S1-hM4Zg" base_Classifier="_lXxIcQ6uEeqas7S1-hM4Zg"/>
</xmi:XMI>
